OGRE: Ogre::v1::PatchMesh Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | List of all members
Ogre::v1::PatchMesh Class Reference
Core » LOD

Patch specialisation of Mesh. More...

`#include <OgrePatchMesh.h>`

Inheritance diagram for Ogre::v1::PatchMesh:
[legend]

## Public Types
typedef MapIterator< VertexBoneAssignmentList > | BoneAssignmentIterator
typedef ConstVectorIterator< PoseList > | ConstPoseIterator
typedef FastArray< unsigned short > | IndexMap
enum | LoadingFlags { LF_DEFAULT = 0, LF_INCLUDE_NON_RELOADABLE = 1, LF_ONLY_UNREFERENCED = 2, LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3, LF_PRESERVE_STATE = 4 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED, LOADSTATE_LOADING, LOADSTATE_LOADED, LOADSTATE_UNLOADING, LOADSTATE_PREPARED, LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...
typedef FastArray< Real > | LodValueArray
typedef vector< MeshLodUsage >::type | MeshLodUsageList
typedef VectorIterator< PoseList > | PoseIterator
typedef VectorIterator< SubMeshList > | SubMeshIterator
typedef vector< SubMesh * >::type | SubMeshList
typedef unordered_map< String, ushort >::type | SubMeshNameMap
| A hashmap used to store optional SubMesh names. More...
typedef multimap< size_t, VertexBoneAssignment >::type | VertexBoneAssignmentList
| Multimap of vertex bone assignments (orders by vertex index). More...

## Public Member Functions
| PatchMesh (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group)
| Constructor. More...
void | _calcBoundsFromVertexBuffer (VertexData *vertexData, AxisAlignedBox &outAABB, Real &outRadius, bool updateOnly=false)
| Calculates. More...
void | _compileBoneAssignments (void)
| Internal method, be called once to compile bone assignments into geometry buffer. More...
void | _computeBoneBoundingRadius ()
| Compute the bone bounding radius by looking at the vertices, vertex-bone-assignments, and skeleton bind pose. More...
void | _determineAnimationTypes (void) const
| Internal method which, if animation types have not been determined, scans any vertex animations and determines the type for each set of vertex data (cannot have 2 different types). More...
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed. More...
virtual void | _fireLoadingComplete (bool wasBackgroundLoaded)
| Firing of loading complete event. More...
virtual void | _firePreparingComplete (bool wasBackgroundLoaded)
| Firing of preparing complete event. More...
virtual void | _fireUnloadingComplete (void)
| Firing of unloading complete event. More...
virtual Animation * | _getAnimationImpl (const String &name) const
| Internal access to the named vertex Animation object - returns null if it does not exist. More...
bool | _getAnimationTypesDirty (void) const
| Are the derived animation types out of date? More...
const LodValueArray * | _getLodValueArray (void) const
ushort | _getSubMeshIndex (const String &name) const
| Gets the index of a submesh with a given name. More...
void | _initAnimationState (AnimationStateSet *animSet)
| Initialise an animation set suitable for use with this mesh. More...
bool | _isManualLodLevel (unsigned short level) const
| Internal methods for loading LOD, do not use. More...
virtual void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin. More...
void | _notifySkeleton (SkeletonPtr &pSkel)
| Internal notification, used to tell the Mesh which Skeleton to use without loading it. More...
unsigned short | _rationaliseBoneAssignments (size_t vertexCount, VertexBoneAssignmentList &assignments)
| Rationalises the passed in bone assignment list. More...
void | _refreshAnimationState (AnimationStateSet *animSet)
| Refresh an animation set suitable for use with this mesh. More...
void | _setBoneBoundingRadius (Real radius)
| Manually set the bone bounding radius. More...
void | _setBoundingSphereRadius (Real radius)
| Manually set the bounding radius. More...
void | _setBounds (const AxisAlignedBox &bounds, bool pad=true)
| Manually set the bounding box for this Mesh. More...
void | _setLodInfo (unsigned short numLevels)
| Internal methods for loading LOD, do not use. More...
void | _setLodUsage (unsigned short level, const MeshLodUsage &usage)
| Internal methods for loading LOD, do not use. More...
void | _setSubMeshLodFaceList (unsigned short subIdx, unsigned short level, IndexData *facedata, bool casterPass)
| Internal methods for loading LOD, do not use. More...
void | _updateBoundsFromVertexBuffers (bool pad=false)
| Automatically update the bounding radius and bounding box for this Mesh. More...
void | _updateCompiledBoneAssignments (void)
| Internal method, be called once to update the compiled bone assignments. More...
void | addBoneAssignment (const VertexBoneAssignment &vertBoneAssign)
| Assigns a vertex to a bone with a given weight, for skeletal animation. More...
virtual void | addListener (Listener *lis)
| Register a listener on this resource. More...
void | arrangeEfficient (bool halfPos, bool halfTexCoords, bool qTangents)
| Rearranges the buffers in this Mesh so that they are more efficient for rendering with shaders. More...
void | buildEdgeList (void)
| Builds an edge list for this mesh, which can be used for generating a shadow volume among other things. More...
void | buildTangentVectors (VertexElementSemantic targetSemantic=VES_TANGENT, unsigned short sourceTexCoordSet=0, unsigned short index=0, bool splitMirrored=false, bool splitRotated=false, bool storeParityInW=false)
| This method builds a set of tangent vectors for a given mesh into a 3D texture coordinate buffer. More...
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource. More...
void | clearBoneAssignments (void)
| Removes all bone assignments for this mesh. More...
MeshPtr | clone (const String &newName, const String &newGroup=BLANKSTRING)
| Makes a copy of this mesh object and gives it a new name. More...
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object. More...
virtual Animation * | createAnimation (const String &name, Real length)
| Creates a new Animation object for vertex animating this mesh. More...
void | createAzdoBuffers (void)
Pose * | createPose (ushort target, const String &name=BLANKSTRING)
| Create a new Pose for this mesh or one of its submeshes. More...
SubMesh * | createSubMesh (const String &name)
| Creates a new SubMesh and gives it a name. More...
SubMesh * | createSubMesh (void)
| Creates a new SubMesh. More...
void | dearrangeToInefficient (void)
| Reverts the effects from arrangeEfficient by converting all 16-bit half float back to 32-bit float; and QTangents to Normal, Tangent + Reflection representation, which are more compatible for doing certain operations vertex operations in the CPU. More...
void | define (void *controlPointBuffer, VertexDeclaration *declaration, size_t width, size_t height, size_t uMaxSubdivisionLevel=PatchSurface::AUTO_LEVEL, size_t vMaxSubdivisionLevel=PatchSurface::AUTO_LEVEL, PatchSurface::VisibleSide visibleSide=PatchSurface::VS_FRONT, HardwareBuffer::Usage vbUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, HardwareBuffer::Usage ibUsage=HardwareBuffer::HBU_DYNAMIC_WRITE_ONLY, bool vbUseShadow=false, bool ibUseShadow=false)
| Define the patch, as defined in MeshManager::createBezierPatch. More...
void | destroySubMesh (const String &name)
| Destroy a SubMesh with the given name. More...
void | destroySubMesh (unsigned short index)
| Destroy a SubMesh with the given index. More...
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource. More...
void | freeEdgeList (void)
| Destroys and frees the edge lists this mesh has built. More...
virtual Animation * | getAnimation (const String &name) const
| Returns the named vertex Animation object. More...
virtual Animation * | getAnimation (unsigned short index) const
| Gets a single morph animation by index. More...
bool | getAutoBuildEdgeLists (void) const
| Sets whether or not this Mesh should automatically build edge lists when asked for them, or whether it should never build them if they are not already provided. More...
BoneAssignmentIterator | getBoneAssignmentIterator (void)
| Gets an iterator for access all bone assignments. More...
const VertexBoneAssignmentList & | getBoneAssignments () const
| Gets a const reference to the list of bone assignments. More...
Real | getBoneBoundingRadius () const
| Gets the radius used to inflate the bounding box around the bones. More...
Real | getBoundingSphereRadius (void) const
| Gets the radius of the bounding sphere surrounding this mesh. More...
const AxisAlignedBox & | getBounds (void) const
| Get the axis-aligned bounding box for this mesh. More...
virtual ResourceManager * | getCreator (void)
| Gets the manager which created this resource. More...
EdgeData * | getEdgeList (unsigned short lodIndex=0)
| Return the edge list for this mesh, building it if required. More...
const EdgeData * | getEdgeList (unsigned short lodIndex=0) const
| Return the edge list for this mesh, building it if required. More...
virtual const String & | getGroup (void) const
| Gets the group which this resource is a member of. More...
virtual ResourceHandle | getHandle (void) const
HardwareBufferManagerBase * | getHardwareBufferManager ()
HardwareBuffer::Usage | getIndexBufferUsage (void) const
| Gets the usage setting for this meshes index buffers. More...
virtual LoadingState | getLoadingState () const
| Returns the current loading state. More...
ushort | getLodIndex (Real value) const
| Retrieves the level of detail index for the given LOD value. More...
const MeshLodUsage & | getLodLevel (ushort index) const
| Gets details of the numbered level of detail entry. More...
const String & | getLodStrategyName (void) const
| Returns the name of the Lod strategy the user lod values have been calibrated for. More...
virtual const String & | getName (void) const
| Gets resource name. More...
virtual unsigned short | getNumAnimations (void) const
| Gets the number of morph animations in this mesh. More...
ushort | getNumLodLevels (void) const
| Returns the number of levels of detail that this mesh supports. More...
unsigned short | getNumSubMeshes (void) const
| Gets the number of sub meshes which comprise this mesh. More...
const SkeletonPtr & | getOldSkeleton (void) const
| Gets a pointer to any linked Skeleton. More...
virtual const String & | getOrigin (void) const
| Get the origin of this resource, e.g. More...
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class. More...
const ParamDictionary * | getParamDictionary (void) const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method. More...
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object. More...
Pose * | getPose (const String &name)
| Retrieve an existing Pose by name. More...
Pose * | getPose (ushort index)
| Retrieve an existing Pose by index. More...
size_t | getPoseCount (void) const
| Get the number of poses. More...
PoseIterator | getPoseIterator (void)
| Get an iterator over all the poses defined. More...
ConstPoseIterator | getPoseIterator (void) const
| Get an iterator over all the poses defined. More...
const PoseList & | getPoseList (void) const
| Get pose list. More...
bool | getSharedVertexDataAnimationIncludesNormals () const
| Returns whether animation on shared vertex data includes normals. More...
virtual VertexAnimationType | getSharedVertexDataAnimationType (void) const
| Gets the type of vertex animation the shared vertex data of this mesh supports. More...
virtual size_t | getSize (void) const
| Retrieves info about the size of the resource. More...
const SkeletonDefPtr & | getSkeleton (void) const
const String & | getSkeletonName (void) const
| Gets the name of any linked Skeleton. More...
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded. More...
SubMesh * | getSubMesh (const String &name) const
| Gets a SubMesh by name. More...
SubMesh * | getSubMesh (unsigned short index) const
| Gets a pointer to the submesh indicated by the index. More...
SubMeshIterator | getSubMeshIterator (void)
| Gets an iterator over the available submeshes. More...
const SubMeshNameMap & | getSubMeshNameMap (void) const
| Gets a reference to the optional name assignments of the SubMeshes. More...
HardwareBuffer::Usage | getVertexBufferUsage (void) const
| Gets the usage setting for this meshes vertex buffers. More...
VertexData * | getVertexDataByTrackHandle (unsigned short handle)
| Gets a pointer to a vertex data element based on a morph animation track handle. More...
virtual bool | hasAnimation (const String &name) const
| Returns whether this mesh contains the named vertex animation. More...
bool | hasIndependentShadowMappingBuffers (void) const
| Returns true if the shadow mapping buffers do not just reference the real buffers, but are rather their own separate set of optimized geometry. More...
bool | hasManualLodLevel (void) const
| Returns true if this mesh has a manual LOD level. More...
bool | hasSkeleton (void) const
| Returns true if this Mesh has a linked Skeleton. More...
bool | hasValidShadowMappingBuffers (void) const
| Returns true if the mesh is ready for rendering with valid shadow mapping buffers Otherwise prepareForShadowMapping must be called on this mesh. More...
bool | hasVertexAnimation (void) const
| Returns whether or not this mesh has some kind of vertex animation. More...
void | importV2 (Ogre::Mesh *mesh)
| Converts a v2 mesh back to v1. More...
virtual bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading. More...
bool | isEdgeListBuilt (void) const
| Returns whether this mesh has an attached edge list. More...
bool | isIndexBufferShadowed (void) const
| Gets whether or not this meshes index buffers are shadowed. More...
virtual bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise. More...
virtual bool | isLoading () const
| Returns whether the resource is currently in the process of background loading. More...
virtual bool | isManuallyLoaded (void) const
| Is this resource manually loaded? More...
virtual bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise. More...
bool | isPreparedForShadowVolumes (void) const
| Returns whether this mesh has already had it's geometry prepared for use in rendering shadow volumes. More...
virtual bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise. More...
bool | isVertexBufferShadowed (void) const
| Gets whether or not this meshes vertex buffers are shadowed. More...
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already. More...
void | mergeAdjacentTexcoords (unsigned short finalTexCoordSet, unsigned short texCoordSetToDestroy)
| This method collapses two texcoords into one for all submeshes where this is possible. More...
void | nameSubMesh (const String &name, ushort index)
| Gives a name to a SubMesh. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already. More...
void | prepareForShadowMapping (bool forceSameBuffers)
void | prepareForShadowVolume (void)
| This method prepares the mesh for generating a renderable shadow volume. More...
void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded. More...
virtual void | removeAllAnimations (void)
| Removes all morph Animations from this mesh. More...
void | removeAllPoses (void)
| Destroy all poses. More...
virtual void | removeAnimation (const String &name)
| Removes vertex Animation from this mesh. More...
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource. More...
void | removeLodLevels (void)
| Removes all LOD data from this Mesh. More...
void | removePose (const String &name)
| Destroy a pose by name. More...
void | removePose (ushort index)
| Destroy a pose by index. More...
void | setAutoBuildEdgeLists (bool autobuild)
| Sets whether or not this Mesh should automatically build edge lists when asked for them, or whether it should never build them if they are not already provided. More...
virtual void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not. More...
void | setHardwareBufferManager (HardwareBufferManagerBase *bufferManager)
| Sets the manager for the vertex and index buffers to be used when loading this Mesh. More...
void | setIndexBufferPolicy (HardwareBuffer::Usage usage, bool shadowBuffer=false)
| Sets the policy for the index buffers to be used when loading this Mesh. More...
void | setLodStrategyName (const String &name)
virtual void | setManuallyLoaded (bool isManual)
| Set "Is this resource manually loaded?". More...
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method. More...
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method. More...
void | setSkeletonName (const String &skelName)
| Sets the name of the skeleton this Mesh uses for animation. More...
void | setSubdivision (Real factor)
virtual void | setToLoaded (void)
| Change the Resource loading state to loaded. More...
void | setVertexBufferPolicy (HardwareBuffer::Usage usage, bool shadowBuffer=false)
| Sets the policy for the vertex buffers to be used when loading this Mesh. More...
bool | suggestTangentVectorBuildParams (VertexElementSemantic targetSemantic, unsigned short &outSourceCoordSet, unsigned short &outIndex)
| Ask the mesh to suggest parameters to a future buildTangentVectors call, should you wish to use texture coordinates to store the tangents. More...
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used. More...
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required. More...
void | unnameSubMesh (const String &name)
| Removes a name from a SubMesh. More...
void | update (void *controlPointBuffer, size_t width, size_t height, size_t uMaxSubdivisionLevel, size_t vMaxSubdivisionLevel, PatchSurface::VisibleSide visibleSide)
| Update the mesh with new control points positions. More...
void | updateManualLodLevel (ushort index, const String &meshName)
| Changes the alternate mesh to use as a manual LOD at the given index. More...
void | updateMaterialForAllSubMeshes (void)
| Iterates through all submeshes and requests them to apply their texture aliases to the material they use. More...

## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. More...
static void | prepareMatricesForVertexBlend (const Matrix4 **blendMatrices, const Matrix4 *boneMatrices, const IndexMap &indexMap)
| Prepare matrices for software indexed vertex blend. More...
static void | softwareVertexBlend (const VertexData *sourceVertexData, const VertexData *targetVertexData, const Matrix4 *const *blendMatrices, size_t numMatrices, bool blendNormals)
| Performs a software indexed vertex blend, of the kind used for skeletal animation although it can be used for other purposes. More...
static void | softwareVertexMorph (Real t, const HardwareVertexBufferSharedPtr &b1, const HardwareVertexBufferSharedPtr &b2, VertexData *targetVertexData)
| Performs a software vertex morph, of the kind used for morph animation although it can be used for other purposes. More...
static void | softwareVertexPoseBlend (Real weight, const map< size_t, Vector3 >::type &vertexOffsetMap, const map< size_t, Vector3 >::type &normalsMap, VertexData *targetVertexData)
| Performs a software vertex pose blend, of the kind used for morph animation although it can be used for other purposes. More...

## Public Attributes
| OGRE_AUTO_MUTEX
IndexMap | sharedBlendIndexToBoneIndexMap
| Shared index map for translating blend index to bone index. More...
VertexData * | sharedVertexData [NumVertexPass]
| Shared vertex data. More...

## Static Public Attributes
static bool | msOptimizeForShadowMapping

## Detailed Description

Patch specialisation of Mesh.

Remarks
  Instances of this class should be created by calling MeshManager::createBezierPatch.

## Member Typedef Documentation

## ◆ BoneAssignmentIterator

typedef MapIterator<VertexBoneAssignmentList> Ogre::v1::Mesh::BoneAssignmentIterator
| inherited

## ◆ ConstPoseIterator

typedef ConstVectorIterator<PoseList> Ogre::v1::Mesh::ConstPoseIterator
| inherited

## ◆ IndexMap

typedef FastArray<unsigned short> Ogre::v1::Mesh::IndexMap
| inherited

## ◆ LodValueArray

typedef FastArray<Real> Ogre::v1::Mesh::LodValueArray
| inherited

## ◆ MeshLodUsageList

typedef vector<MeshLodUsage>::type Ogre::v1::Mesh::MeshLodUsageList
| inherited

## ◆ PoseIterator

typedef VectorIterator<PoseList> Ogre::v1::Mesh::PoseIterator
| inherited

## ◆ SubMeshIterator

typedef VectorIterator<SubMeshList> Ogre::v1::Mesh::SubMeshIterator
| inherited

## ◆ SubMeshList

typedef vector<SubMesh*>::type Ogre::v1::Mesh::SubMeshList
| inherited

## ◆ SubMeshNameMap

typedef unordered_map<String, ushort>::type Ogre::v1::Mesh::SubMeshNameMap
| inherited

A hashmap used to store optional SubMesh names.

Translates a name into SubMesh index.

## ◆ VertexBoneAssignmentList

typedef multimap<size_t, VertexBoneAssignment>::type Ogre::v1::Mesh::VertexBoneAssignmentList
| inherited

Multimap of vertex bone assignments (orders by vertex index).

## Member Enumeration Documentation

## ◆ LoadingFlags

enum Ogre::Resource::LoadingFlags
| inherited

Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior.

Enumerator
LF_DEFAULT | Only reloadable resources are processed, reload restores initial state.
LF_INCLUDE_NON_RELOADABLE | Process non-reloadable resources too.
LF_ONLY_UNREFERENCED | Process only resources which are not referenced by any other object. Usefull to reduce resource consumption.
LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE | Combination of LF_ONLY_UNREFERENCED and LF_INCLUDE_NON_RELOADABLE.
LF_PRESERVE_STATE | Preserve some states during reloading, for example stencil shadows prepareness for Meshes.

## ◆ LoadingState

enum Ogre::Resource::LoadingState
| inherited

Enum identifying the loading state of the resource.

Enumerator
LOADSTATE_UNLOADED | Not loaded.
LOADSTATE_LOADING | Loading is in progress.
LOADSTATE_LOADED | Fully loaded.
LOADSTATE_UNLOADING | Currently unloading.
LOADSTATE_PREPARED | Fully prepared.
LOADSTATE_PREPARING | Preparing is in progress.

## Constructor & Destructor Documentation

## ◆ PatchMesh()

Ogre::v1::PatchMesh::PatchMesh | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group
| ) |  |

Constructor.

## Member Function Documentation

## ◆ _calcBoundsFromVertexBuffer()

void Ogre::v1::Mesh::_calcBoundsFromVertexBuffer | ( | VertexData * | vertexData,
|  | AxisAlignedBox & | outAABB,
|  | Real & | outRadius,
|  | bool | updateOnly = `false`
| ) |  |
| inherited

Calculates.

Remarks
  Calling this method is required when building manual meshes. However it is recommended to use _setBounds and _setBoundingSphereRadius instead, because the vertex buffer may not have a shadow copy in the memory. Reading back the buffer from video memory is very slow!

## ◆ _compileBoneAssignments()

void Ogre::v1::Mesh::_compileBoneAssignments | ( | void |  | ) |
| inherited

Internal method, be called once to compile bone assignments into geometry buffer.

Remarks
  The OGRE engine calls this method automatically. It compiles the information submitted as bone assignments into a format usable in realtime. It also eliminates excessive bone assignments (max is OGRE_MAX_BLEND_WEIGHTS) and re-normalises the remaining assignments.

## ◆ _computeBoneBoundingRadius()

void Ogre::v1::Mesh::_computeBoneBoundingRadius | ( |  | ) |
| inherited

Compute the bone bounding radius by looking at the vertices, vertex-bone-assignments, and skeleton bind pose.

Remarks
  This is automatically called by Entity if necessary. Only does something if the boneBoundingRadius is zero to begin with. Only works if vertex data is readable (i.e. not WRITE_ONLY).

## ◆ _determineAnimationTypes()

void Ogre::v1::Mesh::_determineAnimationTypes | ( | void |  | ) | const
| inherited

Internal method which, if animation types have not been determined, scans any vertex animations and determines the type for each set of vertex data (cannot have 2 different types).

## ◆ _dirtyState()

virtual void Ogre::Resource::_dirtyState | ( |  | ) |
| virtualinherited

Manually mark the state of this resource as having been changed.

Remarks
  You only need to call this from outside if you explicitly want derived objects to think this object has changed.

See also
  getStateCount.

## ◆ _fireLoadingComplete()

virtual void Ogre::Resource::_fireLoadingComplete | ( | bool | wasBackgroundLoaded | ) |
| virtualinherited

Firing of loading complete event.

Remarks
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Parameters

  wasBackgroundLoaded | Whether this was a background loaded event

## ◆ _firePreparingComplete()

virtual void Ogre::Resource::_firePreparingComplete | ( | bool | wasBackgroundLoaded | ) |
| virtualinherited

Firing of preparing complete event.

Remarks
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Parameters

  wasBackgroundLoaded | Whether this was a background loaded event

## ◆ _fireUnloadingComplete()

virtual void Ogre::Resource::_fireUnloadingComplete | ( | void |  | ) |
| virtualinherited

Firing of unloading complete event.

Remarks
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

## ◆ _getAnimationImpl()

virtual Animation* Ogre::v1::Mesh::_getAnimationImpl | ( | const String & | name | ) | const
| virtualinherited

Internal access to the named vertex Animation object - returns null if it does not exist.

Parameters

  name | The name of the animation.

## ◆ _getAnimationTypesDirty()

bool Ogre::v1::Mesh::_getAnimationTypesDirty | ( | void |  | ) | const
| inlineinherited

Are the derived animation types out of date?

## ◆ _getLodValueArray()

const LodValueArray* Ogre::v1::Mesh::_getLodValueArray | ( | void |  | ) | const
| inlineinherited

## ◆ _getSubMeshIndex()

ushort Ogre::v1::Mesh::_getSubMeshIndex | ( | const String & | name | ) | const
| inherited

Gets the index of a submesh with a given name.

Remarks
  Useful if you identify the SubMeshes by name (using nameSubMesh) but wish to have faster repeat access.

## ◆ _initAnimationState()

void Ogre::v1::Mesh::_initAnimationState | ( | AnimationStateSet * | animSet | ) |
| inherited

Initialise an animation set suitable for use with this mesh.

Remarks
  Only recommended for use inside the engine, not by applications.

## ◆ _isManualLodLevel()

bool Ogre::v1::Mesh::_isManualLodLevel | ( | unsigned short | level | ) | const
| inherited

Internal methods for loading LOD, do not use.

## ◆ _notifyOrigin()

virtual void Ogre::Resource::_notifyOrigin | ( | const String & | origin | ) |
| inlinevirtualinherited

Notify this resource of it's origin.

## ◆ _notifySkeleton()

void Ogre::v1::Mesh::_notifySkeleton | ( | SkeletonPtr & | pSkel | ) |
| inherited

Internal notification, used to tell the Mesh which Skeleton to use without loading it.

Remarks
  This is only here for unusual situation where you want to manually set up a Skeleton. Best to let OGRE deal with this, don't call it yourself unless you really know what you're doing.

## ◆ _rationaliseBoneAssignments()

unsigned short Ogre::v1::Mesh::_rationaliseBoneAssignments | ( | size_t | vertexCount,
|  | VertexBoneAssignmentList & | assignments
| ) |  |
| inherited

Rationalises the passed in bone assignment list.

Remarks
  OGRE supports up to 4 bone assignments per vertex. The reason for this limit is that this is the maximum number of assignments that can be passed into a hardware-assisted blending algorithm. This method identifies where there are more than 4 bone assignments for a given vertex, and eliminates the bone assignments with the lowest weights to reduce to this limit. The remaining weights are then re-balanced to ensure that they sum to 1.0.

Parameters

  vertexCount | The number of vertices.
  assignments | The bone assignment list to rationalise. This list will be modified and entries will be removed where the limits are exceeded.

Returns
  The maximum number of bone assignments per vertex found, clamped to [1-4]

## ◆ _refreshAnimationState()

void Ogre::v1::Mesh::_refreshAnimationState | ( | AnimationStateSet * | animSet | ) |
| inherited

Refresh an animation set suitable for use with this mesh.

Remarks
  Only recommended for use inside the engine, not by applications.

## ◆ _setBoneBoundingRadius()

void Ogre::v1::Mesh::_setBoneBoundingRadius | ( | Real | radius | ) |
| inherited

Manually set the bone bounding radius.

Remarks
  This value is normally computed automatically, however it can be overriden with this method.

## ◆ _setBoundingSphereRadius()

void Ogre::v1::Mesh::_setBoundingSphereRadius | ( | Real | radius | ) |
| inherited

Manually set the bounding radius.

Remarks
  Calling this method is required when building manual meshes now, because OGRE can no longer update the bounds for you, because it cannot necessarily read vertex data back from the vertex buffers which this mesh uses (they very well might be write-only, and even if they are not, reading data from a hardware buffer is a bottleneck).

## ◆ _setBounds()

void Ogre::v1::Mesh::_setBounds | ( | const AxisAlignedBox & | bounds,
|  | bool | pad = `true`
| ) |  |
| inherited

Manually set the bounding box for this Mesh.

Remarks
  Calling this method is required when building manual meshes now, because OGRE can no longer update the bounds for you, because it cannot necessarily read vertex data back from the vertex buffers which this mesh uses (they very well might be write-only, and even if they are not, reading data from a hardware buffer is a bottleneck).

Parameters

  pad | If true, a certain padding will be added to the bounding box to separate it from the mesh

## ◆ _setLodInfo()

void Ogre::v1::Mesh::_setLodInfo | ( | unsigned short | numLevels | ) |
| inherited

Internal methods for loading LOD, do not use.

## ◆ _setLodUsage()

void Ogre::v1::Mesh::_setLodUsage | ( | unsigned short | level,
|  | const MeshLodUsage & | usage
| ) |  |
| inherited

Internal methods for loading LOD, do not use.

## ◆ _setSubMeshLodFaceList()

void Ogre::v1::Mesh::_setSubMeshLodFaceList | ( | unsigned short | subIdx,
|  | unsigned short | level,
|  | IndexData * | facedata,
|  | bool | casterPass
| ) |  |
| inherited

Internal methods for loading LOD, do not use.

## ◆ _updateBoundsFromVertexBuffers()

void Ogre::v1::Mesh::_updateBoundsFromVertexBuffers | ( | bool | pad = `false` | ) |
| inherited

Automatically update the bounding radius and bounding box for this Mesh.

Remarks
  Calling this method is required when building manual meshes. However it is recommended to use _setBounds and _setBoundingSphereRadius instead, because the vertex buffer may not have a shadow copy in the memory. Reading back the buffer from video memory is very slow!

Parameters

  pad | If true, a certain padding will be added to the bounding box to separate it from the mesh

## ◆ _updateCompiledBoneAssignments()

void Ogre::v1::Mesh::_updateCompiledBoneAssignments | ( | void |  | ) |
| inherited

Internal method, be called once to update the compiled bone assignments.

Remarks
  The OGRE engine calls this method automatically. It updates the compiled bone assignments if requested.

## ◆ addBoneAssignment()

void Ogre::v1::Mesh::addBoneAssignment | ( | const VertexBoneAssignment & | vertBoneAssign | ) |
| inherited

Assigns a vertex to a bone with a given weight, for skeletal animation.

Remarks
  This method is only valid after calling setSkeletonName. Since this is a one-off process there exists only 'addBoneAssignment' and 'clearBoneAssignments' methods, no 'editBoneAssignment'. You should not need to modify bone assignments during rendering (only the positions of bones) and OGRE reserves the right to do some internal data reformatting of this information, depending on render system requirements.

  This method is for assigning weights to the shared geometry of the Mesh. To assign weights to the per-SubMesh geometry, see the equivalent methods on SubMesh.

## ◆ addListener()

virtual void Ogre::Resource::addListener | ( | Listener * | lis | ) |
| virtualinherited

Register a listener on this resource.

See also
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ arrangeEfficient()

void Ogre::v1::Mesh::arrangeEfficient | ( | bool | halfPos,
|  | bool | halfTexCoords,
|  | bool | qTangents
| ) |  |
| inherited

Rearranges the buffers in this Mesh so that they are more efficient for rendering with shaders.

It's not recommended to use this option if you plan on using SW skinning or pose/morph animations.

Remarks
  Multiple buffer streams will be merged into one, making an interleaved format. Shared vertices with submeshes will be unshared.

Parameters

  halfPos | True if you want to convert the position data to VET_HALF4 format. Recommended on desktop to reduce memory and bandwidth requirements. Rarely the extra precision is needed.

Unfortuntately on mobile, not all ES2 devices support VET_HALF4. Do NOT use this flag if you intend to run the mesh in GLES2 devices which don't have the GL_OES_VERTEX_HALF_FLOAT extension (many iOS, some Android).

Parameters

  halfTexCoords | True if you want to convert the position data to VET_HALF2 or VET_HALF4 format. Same recommendations as halfPos.
  qTangents | True if you want to generate tangent and reflection information (modifying the original v1 mesh) and convert this data to a QTangent, requiring VET_SHORT4_SNORM (8 bytes vs 28 bytes to store normals, tangents and reflection). Needs much less space, trading for more ALU ops in the vertex shader for decoding the QTangent. Highly recommended on both desktop and mobile if you need tangents (i.e. normal mapping).

## ◆ buildEdgeList()

void Ogre::v1::Mesh::buildEdgeList | ( | void |  | ) |
| inherited

Builds an edge list for this mesh, which can be used for generating a shadow volume among other things.

## ◆ buildTangentVectors()

void Ogre::v1::Mesh::buildTangentVectors | ( | VertexElementSemantic | targetSemantic = `VES_TANGENT`,
|  | unsigned short | sourceTexCoordSet = `0`,
|  | unsigned short | index = `0`,
|  | bool | splitMirrored = `false`,
|  | bool | splitRotated = `false`,
|  | bool | storeParityInW = `false`
| ) |  |
| inherited

This method builds a set of tangent vectors for a given mesh into a 3D texture coordinate buffer.

Remarks
  Tangent vectors are vectors representing the local 'X' axis for a given vertex based on the orientation of the 2D texture on the geometry. They are built from a combination of existing normals, and from the 2D texture coordinates already baked into the model. They can be used for a number of things, but most of all they are useful for vertex and fragment programs, when you wish to arrive at a common space for doing per-pixel calculations.

  The prerequisites for calling this method include that the vertex data used by every SubMesh has both vertex normals and 2D texture coordinates.

Parameters

  targetSemantic | The semantic to store the tangents in. Defaults to the explicit tangent binding, but note that this is only usable on more modern hardware (Shader Model 2), so if you need portability with older cards you should change this to a texture coordinate binding instead.
  sourceTexCoordSet | The texture coordinate index which should be used as the source of 2D texture coordinates, with which to calculate the tangents.
  index | The element index, ie the texture coordinate set which should be used to store the 3D coordinates representing a tangent vector per vertex, if targetSemantic is VES_TEXTURE_COORDINATES. If this already exists, it will be overwritten.
  splitMirrored | Sets whether or not to split vertices when a mirrored tangent space transition is detected (matrix parity differs).

See also
  TangentSpaceCalc::setSplitMirrored

Parameters

  splitRotated | Sets whether or not to split vertices when a rotated tangent space is detected.

See also
  TangentSpaceCalc::setSplitRotated

Parameters

  storeParityInW | If `true`, store tangents as a 4-vector and include parity in w.

## ◆ changeGroupOwnership()

virtual void Ogre::Resource::changeGroupOwnership | ( | const String & | newGroup | ) |
| virtualinherited

Change the resource group ownership of a Resource.

Remarks
  This method is generally reserved for internal use, although if you really know what you're doing you can use it to move this resource from one group to another.

Parameters

  newGroup | Name of the new group

## ◆ cleanupDictionary()

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) |
| staticinherited

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

## ◆ clearBoneAssignments()

void Ogre::v1::Mesh::clearBoneAssignments | ( | void |  | ) |
| inherited

Removes all bone assignments for this mesh.

Remarks
  This method is for modifying weights to the shared geometry of the Mesh. To assign weights to the per-SubMesh geometry, see the equivalent methods on SubMesh.

## ◆ clone()

MeshPtr Ogre::v1::Mesh::clone | ( | const String & | newName,
|  | const String & | newGroup = `BLANKSTRING`
| ) |  |
| inherited

Makes a copy of this mesh object and gives it a new name.

Remarks
  This is useful if you want to tweak an existing mesh without affecting the original one. The newly cloned mesh is registered with the MeshManager under the new name.

Parameters

  newName | The name to give the clone.
  newGroup | Optional name of the new group to assign the clone to; if you leave this blank, the clone will be assigned to the same group as this Mesh.

## ◆ copyParametersTo()

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const
| inlinevirtualinherited

Method for copying this object's parameters to another object.

Remarks
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters

  dest | Pointer to object to have it's parameters set the same as this object.

References Ogre::StringInterface::setParameter().

## ◆ createAnimation()

virtual Animation* Ogre::v1::Mesh::createAnimation | ( | const String & | name,
|  | Real | length
| ) |  |
| virtualinherited

Creates a new Animation object for vertex animating this mesh.

Parameters

  name | The name of this animation.
  length | The length of the animation in seconds.

Implements Ogre::v1::AnimationContainer.

## ◆ createAzdoBuffers()

void Ogre::v1::Mesh::createAzdoBuffers | ( | void |  | ) |
| inherited

## ◆ createPose()

Pose* Ogre::v1::Mesh::createPose | ( | ushort | target,
|  | const String & | name = `BLANKSTRING`
| ) |  |
| inherited

Create a new Pose for this mesh or one of its submeshes.

Parameters

  target | The target geometry index; 0 is the shared Mesh geometry, 1+ is the dedicated SubMesh geometry belonging to submesh index + 1.
  name | Name to give the pose, which is optional.

Returns
  A new Pose ready for population.

## ◆ createSubMesh() [1/2]

SubMesh* Ogre::v1::Mesh::createSubMesh | ( | const String & | name | ) |
| inherited

Creates a new SubMesh and gives it a name.

## ◆ createSubMesh() [2/2]

SubMesh* Ogre::v1::Mesh::createSubMesh | ( | void |  | ) |
| inherited

Creates a new SubMesh.

Remarks
  Method for manually creating geometry for the mesh. Note - use with extreme caution - you must be sure that you have set up the geometry properly.

## ◆ dearrangeToInefficient()

void Ogre::v1::Mesh::dearrangeToInefficient | ( | void |  | ) |
| inherited

Reverts the effects from arrangeEfficient by converting all 16-bit half float back to 32-bit float; and QTangents to Normal, Tangent + Reflection representation, which are more compatible for doing certain operations vertex operations in the CPU.

## ◆ define()

void Ogre::v1::PatchMesh::define | ( | void * | controlPointBuffer,
|  | VertexDeclaration * | declaration,
|  | size_t | width,
|  | size_t | height,
|  | size_t | uMaxSubdivisionLevel = `PatchSurface::AUTO_LEVEL`,
|  | size_t | vMaxSubdivisionLevel = `PatchSurface::AUTO_LEVEL`,
|  | PatchSurface::VisibleSide | visibleSide = `PatchSurface::VS_FRONT`,
|  | HardwareBuffer::Usage | vbUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | HardwareBuffer::Usage | ibUsage = `HardwareBuffer::HBU_DYNAMIC_WRITE_ONLY`,
|  | bool | vbUseShadow = `false`,
|  | bool | ibUseShadow = `false`
| ) |  |

Define the patch, as defined in MeshManager::createBezierPatch.

## ◆ destroySubMesh() [1/2]

void Ogre::v1::Mesh::destroySubMesh | ( | const String & | name | ) |
| inherited

Destroy a SubMesh with the given name.

Note
  This will invalidate the contents of any existing Entity, or any other object that is referring to the SubMesh list. Entity will detect this and reinitialise, but it is still a disruptive action.

## ◆ destroySubMesh() [2/2]

void Ogre::v1::Mesh::destroySubMesh | ( | unsigned short | index | ) |
| inherited

Destroy a SubMesh with the given index.

Note
  This will invalidate the contents of any existing Entity, or any other object that is referring to the SubMesh list. Entity will detect this and reinitialise, but it is still a disruptive action.

## ◆ escalateLoading()

virtual void Ogre::Resource::escalateLoading | ( |  | ) |
| virtualinherited

Escalates the loading of a background loaded resource.

Remarks
  If a resource is set to load in the background, but something needs it before it's been loaded, there could be a problem. If the user of this resource really can't wait, they can escalate the loading which basically pulls the loading into the current thread immediately. If the resource is already being loaded but just hasn't quite finished then this method will simply wait until the background load is complete.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ freeEdgeList()

void Ogre::v1::Mesh::freeEdgeList | ( | void |  | ) |
| inherited

Destroys and frees the edge lists this mesh has built.

## ◆ getAnimation() [1/2]

virtual Animation* Ogre::v1::Mesh::getAnimation | ( | const String & | name | ) | const
| virtualinherited

Returns the named vertex Animation object.

Parameters

  name | The name of the animation.

Implements Ogre::v1::AnimationContainer.

## ◆ getAnimation() [2/2]

virtual Animation* Ogre::v1::Mesh::getAnimation | ( | unsigned short | index | ) | const
| virtualinherited

Gets a single morph animation by index.

Implements Ogre::v1::AnimationContainer.

## ◆ getAutoBuildEdgeLists()

bool Ogre::v1::Mesh::getAutoBuildEdgeLists | ( | void |  | ) | const
| inlineinherited

Sets whether or not this Mesh should automatically build edge lists when asked for them, or whether it should never build them if they are not already provided.

## ◆ getBoneAssignmentIterator()

BoneAssignmentIterator Ogre::v1::Mesh::getBoneAssignmentIterator | ( | void |  | ) |
| inherited

Gets an iterator for access all bone assignments.

## ◆ getBoneAssignments()

const VertexBoneAssignmentList& Ogre::v1::Mesh::getBoneAssignments | ( |  | ) | const
| inlineinherited

Gets a const reference to the list of bone assignments.

## ◆ getBoneBoundingRadius()

Real Ogre::v1::Mesh::getBoneBoundingRadius | ( |  | ) | const
| inherited

Gets the radius used to inflate the bounding box around the bones.

## ◆ getBoundingSphereRadius()

Real Ogre::v1::Mesh::getBoundingSphereRadius | ( | void |  | ) | const
| inherited

Gets the radius of the bounding sphere surrounding this mesh.

## ◆ getBounds()

const AxisAlignedBox& Ogre::v1::Mesh::getBounds | ( | void |  | ) | const
| inherited

Get the axis-aligned bounding box for this mesh.

## ◆ getCreator()

virtual ResourceManager* Ogre::Resource::getCreator | ( | void |  | ) |
| inlinevirtualinherited

Gets the manager which created this resource.

## ◆ getEdgeList() [1/2]

EdgeData* Ogre::v1::Mesh::getEdgeList | ( | unsigned short | lodIndex = `0` | ) |
| inherited

Return the edge list for this mesh, building it if required.

Remarks
  You must ensure that the Mesh as been prepared for shadow volume rendering if you intend to use this information for that purpose.

Parameters

  lodIndex | The LOD at which to get the edge list, 0 being the highest.

## ◆ getEdgeList() [2/2]

const EdgeData* Ogre::v1::Mesh::getEdgeList | ( | unsigned short | lodIndex = `0` | ) | const
| inherited

Return the edge list for this mesh, building it if required.

Remarks
  You must ensure that the Mesh as been prepared for shadow volume rendering if you intend to use this information for that purpose.

Parameters

  lodIndex | The LOD at which to get the edge list, 0 being the highest.

## ◆ getGroup()

virtual const String& Ogre::Resource::getGroup | ( | void |  | ) | const
| inlinevirtualinherited

Gets the group which this resource is a member of.

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ getHandle()

virtual ResourceHandle Ogre::Resource::getHandle | ( | void |  | ) | const
| inlinevirtualinherited

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ getHardwareBufferManager()

HardwareBufferManagerBase* Ogre::v1::Mesh::getHardwareBufferManager | ( |  | ) |
| inherited

## ◆ getIndexBufferUsage()

HardwareBuffer::Usage Ogre::v1::Mesh::getIndexBufferUsage | ( | void |  | ) | const
| inlineinherited

Gets the usage setting for this meshes index buffers.

## ◆ getLoadingState()

virtual LoadingState Ogre::Resource::getLoadingState | ( |  | ) | const
| inlinevirtualinherited

Returns the current loading state.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

References Ogre::AtomicScalar< T >::get().

## ◆ getLodIndex()

ushort Ogre::v1::Mesh::getLodIndex | ( | Real | value | ) | const
| inherited

Retrieves the level of detail index for the given LOD value.

Note
  The value passed in is the 'transformed' value. If you are dealing with an original source value (e.g. distance), use LodStrategy::transformUserValue to turn this into a lookup value.

## ◆ getLodLevel()

const MeshLodUsage& Ogre::v1::Mesh::getLodLevel | ( | ushort | index | ) | const
| inherited

Gets details of the numbered level of detail entry.

## ◆ getLodStrategyName()

const String& Ogre::v1::Mesh::getLodStrategyName | ( | void |  | ) | const
| inlineinherited

Returns the name of the Lod strategy the user lod values have been calibrated for.

## ◆ getName()

virtual const String& Ogre::Resource::getName | ( | void |  | ) | const
| inlinevirtualinherited

Gets resource name.

Reimplemented in Ogre::v1::OldSkeletonInstance.

Referenced by Ogre::GpuProgramUsage::getProgramName().

## ◆ getNumAnimations()

virtual unsigned short Ogre::v1::Mesh::getNumAnimations | ( | void |  | ) | const
| virtualinherited

Gets the number of morph animations in this mesh.

Implements Ogre::v1::AnimationContainer.

## ◆ getNumLodLevels()

ushort Ogre::v1::Mesh::getNumLodLevels | ( | void |  | ) | const
| inherited

Returns the number of levels of detail that this mesh supports.

Remarks
  This number includes the original model.

## ◆ getNumSubMeshes()

unsigned short Ogre::v1::Mesh::getNumSubMeshes | ( | void |  | ) | const
| inherited

Gets the number of sub meshes which comprise this mesh.

## ◆ getOldSkeleton()

const SkeletonPtr& Ogre::v1::Mesh::getOldSkeleton | ( | void |  | ) | const
| inherited

Gets a pointer to any linked Skeleton.

Returns
  Weak reference to the skeleton - copy this if you want to hold a strong pointer.

## ◆ getOrigin()

virtual const String& Ogre::Resource::getOrigin | ( | void |  | ) | const
| inlinevirtualinherited

Get the origin of this resource, e.g.

a script file name.

Remarks
  This property will only contain something if the creator of this resource chose to populate it. Script loaders are advised to populate it.

## ◆ getParamDictionary() [1/2]

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) |
| inlineinherited

Retrieves the parameter dictionary for this class.

Remarks
  Only valid to call this after createParamDictionary.

Returns
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

## ◆ getParamDictionary() [2/2]

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const
| inlineinherited

## ◆ getParameter()

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const
| inlinevirtualinherited

Generic parameter retrieval method.

Remarks
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters

  name | The name of the parameter to get

Returns
  String value of parameter, blank if not found

References Ogre::ParamCommand::doGet().

## ◆ getParameters()

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const
| inherited

Retrieves a list of parameters valid for this object.

Returns
  A reference to a static list of ParameterDef objects.

## ◆ getPose() [1/2]

Pose* Ogre::v1::Mesh::getPose | ( | const String & | name | ) |
| inherited

Retrieve an existing Pose by name.

## ◆ getPose() [2/2]

Pose* Ogre::v1::Mesh::getPose | ( | ushort | index | ) |
| inherited

Retrieve an existing Pose by index.

## ◆ getPoseCount()

size_t Ogre::v1::Mesh::getPoseCount | ( | void |  | ) | const
| inlineinherited

Get the number of poses.

## ◆ getPoseIterator() [1/2]

PoseIterator Ogre::v1::Mesh::getPoseIterator | ( | void |  | ) |
| inherited

Get an iterator over all the poses defined.

## ◆ getPoseIterator() [2/2]

ConstPoseIterator Ogre::v1::Mesh::getPoseIterator | ( | void |  | ) | const
| inherited

Get an iterator over all the poses defined.

## ◆ getPoseList()

const PoseList& Ogre::v1::Mesh::getPoseList | ( | void |  | ) | const
| inherited

Get pose list.

## ◆ getSharedVertexDataAnimationIncludesNormals()

bool Ogre::v1::Mesh::getSharedVertexDataAnimationIncludesNormals | ( |  | ) | const
| inlineinherited

Returns whether animation on shared vertex data includes normals.

## ◆ getSharedVertexDataAnimationType()

virtual VertexAnimationType Ogre::v1::Mesh::getSharedVertexDataAnimationType | ( | void |  | ) | const
| virtualinherited

Gets the type of vertex animation the shared vertex data of this mesh supports.

## ◆ getSize()

virtual size_t Ogre::Resource::getSize | ( | void |  | ) | const
| inlinevirtualinherited

Retrieves info about the size of the resource.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ getSkeleton()

const SkeletonDefPtr& Ogre::v1::Mesh::getSkeleton | ( | void |  | ) | const
| inlineinherited

## ◆ getSkeletonName()

const String& Ogre::v1::Mesh::getSkeletonName | ( | void |  | ) | const
| inherited

Gets the name of any linked Skeleton.

## ◆ getStateCount()

virtual size_t Ogre::Resource::getStateCount | ( |  | ) | const
| inlinevirtualinherited

Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.

Objects that build derived data based on the resource can check this value against a copy they kept last time they built this derived data, in order to know whether it needs rebuilding. This is a nice way of monitoring changes without having a tightly-bound callback.

## ◆ getSubMesh() [1/2]

SubMesh* Ogre::v1::Mesh::getSubMesh | ( | const String & | name | ) | const
| inherited

Gets a SubMesh by name.

## ◆ getSubMesh() [2/2]

SubMesh* Ogre::v1::Mesh::getSubMesh | ( | unsigned short | index | ) | const
| inherited

Gets a pointer to the submesh indicated by the index.

## ◆ getSubMeshIterator()

SubMeshIterator Ogre::v1::Mesh::getSubMeshIterator | ( | void |  | ) |
| inlineinherited

Gets an iterator over the available submeshes.

## ◆ getSubMeshNameMap()

const SubMeshNameMap& Ogre::v1::Mesh::getSubMeshNameMap | ( | void |  | ) | const
| inlineinherited

Gets a reference to the optional name assignments of the SubMeshes.

## ◆ getVertexBufferUsage()

HardwareBuffer::Usage Ogre::v1::Mesh::getVertexBufferUsage | ( | void |  | ) | const
| inlineinherited

Gets the usage setting for this meshes vertex buffers.

## ◆ getVertexDataByTrackHandle()

VertexData* Ogre::v1::Mesh::getVertexDataByTrackHandle | ( | unsigned short | handle | ) |
| inherited

Gets a pointer to a vertex data element based on a morph animation track handle.

Remarks
  0 means the shared vertex data, 1+ means a submesh vertex data (index+1)

## ◆ hasAnimation()

virtual bool Ogre::v1::Mesh::hasAnimation | ( | const String & | name | ) | const
| virtualinherited

Returns whether this mesh contains the named vertex animation.

Implements Ogre::v1::AnimationContainer.

## ◆ hasIndependentShadowMappingBuffers()

bool Ogre::v1::Mesh::hasIndependentShadowMappingBuffers | ( | void |  | ) | const
| inherited

Returns true if the shadow mapping buffers do not just reference the real buffers, but are rather their own separate set of optimized geometry.

## ◆ hasManualLodLevel()

bool Ogre::v1::Mesh::hasManualLodLevel | ( | void |  | ) | const
| inlineinherited

Returns true if this mesh has a manual LOD level.

Remarks
  A mesh can either use automatically generated LOD, or it can use alternative meshes as provided by an artist.

## ◆ hasSkeleton()

bool Ogre::v1::Mesh::hasSkeleton | ( | void |  | ) | const
| inherited

Returns true if this Mesh has a linked Skeleton.

## ◆ hasValidShadowMappingBuffers()

bool Ogre::v1::Mesh::hasValidShadowMappingBuffers | ( | void |  | ) | const
| inherited

Returns true if the mesh is ready for rendering with valid shadow mapping buffers Otherwise prepareForShadowMapping must be called on this mesh.

## ◆ hasVertexAnimation()

bool Ogre::v1::Mesh::hasVertexAnimation | ( | void |  | ) | const
| inherited

Returns whether or not this mesh has some kind of vertex animation.

## ◆ importV2()

void Ogre::v1::Mesh::importV2 | ( | Ogre::Mesh * | mesh | ) |
| inherited

Converts a v2 mesh back to v1.

## ◆ isBackgroundLoaded()

virtual bool Ogre::Resource::isBackgroundLoaded | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether this Resource has been earmarked for background loading.

Remarks
  This option only makes sense when you have built Ogre with thread support (OGRE_THREAD_SUPPORT). If a resource has been marked for background loading, then it won't load on demand like normal when load() is called. Instead, it will ignore request to load() except if the caller indicates it is the background loader. Any other users of this resource should check isLoaded(), and if that returns false, don't use the resource and come back later.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isEdgeListBuilt()

bool Ogre::v1::Mesh::isEdgeListBuilt | ( | void |  | ) | const
| inlineinherited

Returns whether this mesh has an attached edge list.

## ◆ isIndexBufferShadowed()

bool Ogre::v1::Mesh::isIndexBufferShadowed | ( | void |  | ) | const
| inlineinherited

Gets whether or not this meshes index buffers are shadowed.

## ◆ isLoaded()

virtual bool Ogre::Resource::isLoaded | ( | void |  | ) | const
| inlinevirtualinherited

Returns true if the Resource has been loaded, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

References Ogre::AtomicScalar< T >::get().

## ◆ isLoading()

virtual bool Ogre::Resource::isLoading | ( |  | ) | const
| inlinevirtualinherited

Returns whether the resource is currently in the process of background loading.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

References Ogre::AtomicScalar< T >::get().

## ◆ isManuallyLoaded()

virtual bool Ogre::Resource::isManuallyLoaded | ( | void |  | ) | const
| inlinevirtualinherited

Is this resource manually loaded?

## ◆ isPrepared()

virtual bool Ogre::Resource::isPrepared | ( | void |  | ) | const
| inlinevirtualinherited

Returns true if the Resource has been prepared, false otherwise.

References Ogre::AtomicScalar< T >::get().

## ◆ isPreparedForShadowVolumes()

bool Ogre::v1::Mesh::isPreparedForShadowVolumes | ( | void |  | ) | const
| inlineinherited

Returns whether this mesh has already had it's geometry prepared for use in rendering shadow volumes.

## ◆ isReloadable()

virtual bool Ogre::Resource::isReloadable | ( | void |  | ) | const
| inlinevirtualinherited

Returns true if the Resource is reloadable, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isVertexBufferShadowed()

bool Ogre::v1::Mesh::isVertexBufferShadowed | ( | void |  | ) | const
| inlineinherited

Gets whether or not this meshes vertex buffers are shadowed.

## ◆ load()

virtual void Ogre::Resource::load | ( | bool | backgroundThread = `false` | ) |
| virtualinherited

Loads the resource, if it is not already.

Remarks
  If the resource is loaded from a file, loading is automatic. If not, if for example this resource gained it's data from procedural calls rather than loading from a file, then this resource will not reload on it's own.

Parameters

  backgroundThread | Indicates whether the caller of this method is the background resource loading thread.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ mergeAdjacentTexcoords()

void Ogre::v1::Mesh::mergeAdjacentTexcoords | ( | unsigned short | finalTexCoordSet,
|  | unsigned short | texCoordSetToDestroy
| ) |  |
| inherited

This method collapses two texcoords into one for all submeshes where this is possible.

Remarks
  Often a submesh can have two tex. coords. (i.e. TEXCOORD0 & TEXCOORD1), being both composed of two floats. There are many practical reasons why it would be more convenient to merge both of them into one TEXCOORD0 of 4 floats. This function does exactly that The finalTexCoordSet must have enough space for the merge, or else the submesh will be skipped. (i.e. you can't merge a tex. coord with 3 floats with one having 2 floats)

finalTexCoordSet & texCoordSetToDestroy must be in the same buffer source, and must be adjacent.

Parameters

  finalTexCoordSet | The tex. coord index to merge to. Should have enough space to actually work.
  texCoordSetToDestroy | The texture coordinate index that will disappear on successful merges.

## ◆ nameSubMesh()

void Ogre::v1::Mesh::nameSubMesh | ( | const String & | name,
|  | ushort | index
| ) |  |
| inherited

Gives a name to a SubMesh.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ prepare()

virtual void Ogre::Resource::prepare | ( | bool | backgroundThread = `false` | ) |
| virtualinherited

Prepares the resource for load, if it is not already.

One can call prepare() before load(), but this is not required as load() will call prepare() itself, if needed. When OGRE_THREAD_SUPPORT==1 both load() and prepare() are thread-safe. When OGRE_THREAD_SUPPORT==2 however, only prepare() is thread-safe. The reason for this function is to allow a background thread to do some of the loading work, without requiring the whole render system to be thread-safe. The background thread would call prepare() while the main render loop would later call load(). So long as prepare() remains thread-safe, subclasses can arbitrarily split the work of loading a resource between load() and prepare(). It is best to try and do as much work in prepare(), however, since this will leave less work for the main render thread to do and thus increase FPS.

Parameters

  backgroundThread | Whether this is occurring in a background thread

## ◆ prepareForShadowMapping()

void Ogre::v1::Mesh::prepareForShadowMapping | ( | bool | forceSameBuffers | ) |
| inherited

## ◆ prepareForShadowVolume()

void Ogre::v1::Mesh::prepareForShadowVolume | ( | void |  | ) |
| inherited

This method prepares the mesh for generating a renderable shadow volume.

Remarks
  Preparing a mesh to generate a shadow volume involves firstly ensuring that the vertex buffer containing the positions for the mesh is a standalone vertex buffer, with no other components in it. This method will therefore break apart any existing vertex buffers this mesh holds if position is sharing a vertex buffer. Secondly, it will double the size of this vertex buffer so that there are 2 copies of the position data for the mesh. The first half is used for the original, and the second half is used for the 'extruded' version of the mesh. The vertex count of the main VertexData used to render the mesh will remain the same though, so as not to add any overhead to regular rendering of the object. Both copies of the position are required in one buffer because shadow volumes stretch from the original mesh to the extruded version.

  Because shadow volumes are rendered in turn, no additional index buffer space is allocated by this method, a shared index buffer allocated by the shadow rendering algorithm is used for addressing this extended vertex buffer.

## ◆ prepareMatricesForVertexBlend()

static void Ogre::v1::Mesh::prepareMatricesForVertexBlend | ( | const Matrix4 ** | blendMatrices,
|  | const Matrix4 * | boneMatrices,
|  | const IndexMap & | indexMap
| ) |  |
| staticinherited

Prepare matrices for software indexed vertex blend.

Remarks
  This function organise bone indexed matrices to blend indexed matrices, so software vertex blending can access to the matrix via blend index directly.

Parameters

  blendMatrices | Pointer to an array of matrix pointers to store prepared results, which indexed by blend index.
  boneMatrices | Pointer to an array of matrices to be used to blend, which indexed by bone index.
  indexMap | The index map used to translate blend index to bone index.

## ◆ reload()

void Ogre::v1::Mesh::reload | ( | LoadingFlags | flags = `LF_DEFAULT` | ) |
| virtualinherited

Reloads the resource, if it is already loaded.

Remarks
  Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens.

Reimplemented from Ogre::Resource.

## ◆ removeAllAnimations()

virtual void Ogre::v1::Mesh::removeAllAnimations | ( | void |  | ) |
| virtualinherited

Removes all morph Animations from this mesh.

## ◆ removeAllPoses()

void Ogre::v1::Mesh::removeAllPoses | ( | void |  | ) |
| inherited

Destroy all poses.

## ◆ removeAnimation()

virtual void Ogre::v1::Mesh::removeAnimation | ( | const String & | name | ) |
| virtualinherited

Removes vertex Animation from this mesh.

Implements Ogre::v1::AnimationContainer.

## ◆ removeListener()

virtual void Ogre::Resource::removeListener | ( | Listener * | lis | ) |
| virtualinherited

Remove a listener on this resource.

See also
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ removeLodLevels()

void Ogre::v1::Mesh::removeLodLevels | ( | void |  | ) |
| inherited

Removes all LOD data from this Mesh.

## ◆ removePose() [1/2]

void Ogre::v1::Mesh::removePose | ( | const String & | name | ) |
| inherited

Destroy a pose by name.

Note
  This will invalidate any animation tracks referring to this pose or those after it.

## ◆ removePose() [2/2]

void Ogre::v1::Mesh::removePose | ( | ushort | index | ) |
| inherited

Destroy a pose by index.

Note
  This will invalidate any animation tracks referring to this pose or those after it.

## ◆ setAutoBuildEdgeLists()

void Ogre::v1::Mesh::setAutoBuildEdgeLists | ( | bool | autobuild | ) |
| inlineinherited

Sets whether or not this Mesh should automatically build edge lists when asked for them, or whether it should never build them if they are not already provided.

Remarks
  This allows you to create meshes which do not have edge lists calculated, because you never want to use them. This value defaults to 'true' for mesh formats which did not include edge data, and 'false' for newer formats, where edge lists are expected to have been generated in advance.

## ◆ setBackgroundLoaded()

virtual void Ogre::Resource::setBackgroundLoaded | ( | bool | bl | ) |
| inlinevirtualinherited

Tells the resource whether it is background loaded or not.

Remarks

See also
  Resource::isBackgroundLoaded . Note that calling this only defers the normal on-demand loading behaviour of a resource, it does not actually set up a thread to make sure the resource gets loaded in the background. You should use ResourceBackgroundLoadingQueue to manage the actual loading (which will call this method itself).

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ setHardwareBufferManager()

void Ogre::v1::Mesh::setHardwareBufferManager | ( | HardwareBufferManagerBase * | bufferManager | ) |
| inlineinherited

Sets the manager for the vertex and index buffers to be used when loading this Mesh.

Remarks
  By default, when loading the Mesh, static, write-only vertex and index buffers will be used where possible in order to improve rendering performance. However, such buffers cannot be manipulated on the fly by CPU code (although shader code can). If you wish to use the CPU to modify these buffers and will never use it with GPU, you should call this method. Note, however, that it only takes effect after the Mesh has been reloaded. Note that you still have the option of manually repacing the buffers in this mesh with your own if you see fit too, in which case you don't need to call this method since it only affects buffers created by the mesh itself.

  You can define the approach to a Mesh by changing the default parameters to MeshManager::load if you wish; this means the Mesh is loaded with those options the first time instead of you having to reload the mesh after changing these options.

Parameters

  bufferManager | If set to `DefaultHardwareBufferManager`, the buffers will be created in system memory only, without hardware counterparts. Such mesh could not be rendered, but LODs could be generated for such mesh, it could be cloned, transformed and serialized.

## ◆ setIndexBufferPolicy()

void Ogre::v1::Mesh::setIndexBufferPolicy | ( | HardwareBuffer::Usage | usage,
|  | bool | shadowBuffer = `false`
| ) |  |
| inherited

Sets the policy for the index buffers to be used when loading this Mesh.

Remarks
  By default, when loading the Mesh, static, write-only vertex and index buffers will be used where possible in order to improve rendering performance. However, such buffers cannot be manipulated on the fly by CPU code (although shader code can). If you wish to use the CPU to modify these buffers, you should call this method. Note, however, that it only takes effect after the Mesh has been reloaded. Note that you still have the option of manually repacing the buffers in this mesh with your own if you see fit too, in which case you don't need to call this method since it only affects buffers created by the mesh itself.

  You can define the approach to a Mesh by changing the default parameters to MeshManager::load if you wish; this means the Mesh is loaded with those options the first time instead of you having to reload the mesh after changing these options.

Parameters

  usage | The usage flags, which by default are HardwareBuffer::HBU_STATIC_WRITE_ONLY
  shadowBuffer | If set to `true`, the index buffers will be created with a system memory shadow buffer. You should set this if you want to be able to read from the buffer, because reading from a hardware buffer is a no-no.

## ◆ setLodStrategyName()

void Ogre::v1::Mesh::setLodStrategyName | ( | const String & | name | ) |
| inlineinherited

## ◆ setManuallyLoaded()

virtual void Ogre::Resource::setManuallyLoaded | ( | bool | isManual | ) |
| inlinevirtualinherited

Set "Is this resource manually loaded?".

## ◆ setParameter()

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) |  |
| virtualinherited

Generic parameter setting method.

Remarks
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  name | The name of the parameter to set
  value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

## ◆ setParameterList()

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) |
| virtualinherited

Generic multiple parameter setting method.

Remarks
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  paramList | Name/value pair list

## ◆ setSkeletonName()

void Ogre::v1::Mesh::setSkeletonName | ( | const String & | skelName | ) |
| inherited

Sets the name of the skeleton this Mesh uses for animation.

Remarks
  Meshes can optionally be assigned a skeleton which can be used to animate the mesh through bone assignments. The default is for the Mesh to use no skeleton. Calling this method with a valid skeleton filename will cause the skeleton to be loaded if it is not already (a single skeleton can be shared by many Mesh objects).

Parameters

  skelName | The name of the .skeleton file to use, or an empty string to use no skeleton

## ◆ setSubdivision()

void Ogre::v1::PatchMesh::setSubdivision | ( | Real | factor | ) |

## ◆ setToLoaded()

virtual void Ogre::Resource::setToLoaded | ( | void |  | ) |
| inlinevirtualinherited

Change the Resource loading state to loaded.

References Ogre::AtomicScalar< T >::set().

## ◆ setVertexBufferPolicy()

void Ogre::v1::Mesh::setVertexBufferPolicy | ( | HardwareBuffer::Usage | usage,
|  | bool | shadowBuffer = `false`
| ) |  |
| inherited

Sets the policy for the vertex buffers to be used when loading this Mesh.

Remarks
  By default, when loading the Mesh, static, write-only vertex and index buffers will be used where possible in order to improve rendering performance. However, such buffers cannot be manipulated on the fly by CPU code (although shader code can). If you wish to use the CPU to modify these buffers, you should call this method. Note, however, that it only takes effect after the Mesh has been reloaded. Note that you still have the option of manually repacing the buffers in this mesh with your own if you see fit too, in which case you don't need to call this method since it only affects buffers created by the mesh itself.

  You can define the approach to a Mesh by changing the default parameters to MeshManager::load if you wish; this means the Mesh is loaded with those options the first time instead of you having to reload the mesh after changing these options.

Parameters

  usage | The usage flags, which by default are HardwareBuffer::HBU_STATIC_WRITE_ONLY
  shadowBuffer | If set to `true`, the vertex buffers will be created with a system memory shadow buffer. You should set this if you want to be able to read from the buffer, because reading from a hardware buffer is a no-no.

## ◆ softwareVertexBlend()

static void Ogre::v1::Mesh::softwareVertexBlend | ( | const VertexData * | sourceVertexData,
|  | const VertexData * | targetVertexData,
|  | const Matrix4 *const * | blendMatrices,
|  | size_t | numMatrices,
|  | bool | blendNormals
| ) |  |
| staticinherited

Performs a software indexed vertex blend, of the kind used for skeletal animation although it can be used for other purposes.

Remarks
  This function is supplied to update vertex data with blends done in software, either because no hardware support is available, or that you need the results of the blend for some other CPU operations.

Parameters

  sourceVertexData | VertexData class containing positions, normals, blend indices and blend weights.
  targetVertexData | VertexData class containing target position and normal buffers which will be updated with the blended versions. Note that the layout of the source and target position / normal buffers must be identical, ie they must use the same buffer indexes
  blendMatrices | Pointer to an array of matrix pointers to be used to blend, indexed by blend indices in the sourceVertexData
  numMatrices | Number of matrices in the blendMatrices, it might be used as a hint for optimisation.
  blendNormals | If `true`, normals are blended as well as positions.

## ◆ softwareVertexMorph()

static void Ogre::v1::Mesh::softwareVertexMorph | ( | Real | t,
|  | const HardwareVertexBufferSharedPtr & | b1,
|  | const HardwareVertexBufferSharedPtr & | b2,
|  | VertexData * | targetVertexData
| ) |  |
| staticinherited

Performs a software vertex morph, of the kind used for morph animation although it can be used for other purposes.

Remarks
  This function will linearly interpolate positions between two source buffers, into a third buffer.

Parameters

  t | Parametric distance between the start and end buffer positions.
  b1 | Vertex buffer containing VET_FLOAT3 entries for the start positions.
  b2 | Vertex buffer containing VET_FLOAT3 entries for the end positions.
  targetVertexData | VertexData destination; assumed to have a separate position buffer already bound, and the number of vertices must agree with the number in start and end

## ◆ softwareVertexPoseBlend()

static void Ogre::v1::Mesh::softwareVertexPoseBlend | ( | Real | weight,
|  | const map< size_t, Vector3 >::type & | vertexOffsetMap,
|  | const map< size_t, Vector3 >::type & | normalsMap,
|  | VertexData * | targetVertexData
| ) |  |
| staticinherited

Performs a software vertex pose blend, of the kind used for morph animation although it can be used for other purposes.

Remarks
  This function will apply a weighted offset to the positions in the incoming vertex data (therefore this is a read/write operation, and if you expect to call it more than once with the same data, then you would be best to suppress hardware uploads of the position buffer for the duration).

Parameters

  weight | Parametric weight to scale the offsets by.
  vertexOffsetMap | Potentially sparse map of vertex index -> offset.
  normalsMap | Potentially sparse map of vertex index -> normal.
  targetVertexData | VertexData destination; assumed to have a separate position buffer already bound, and the number of vertices must agree with the number in start and end.

## ◆ suggestTangentVectorBuildParams()

bool Ogre::v1::Mesh::suggestTangentVectorBuildParams | ( | VertexElementSemantic | targetSemantic,
|  | unsigned short & | outSourceCoordSet,
|  | unsigned short & | outIndex
| ) |  |
| inherited

Ask the mesh to suggest parameters to a future buildTangentVectors call, should you wish to use texture coordinates to store the tangents.

Remarks
  This helper method will suggest source and destination texture coordinate sets for a call to buildTangentVectors. It will detect when there are inappropriate conditions (such as multiple geometry sets which don't agree). Moreover, it will return 'true' if it detects that there are aleady 3D coordinates in the mesh, and therefore tangents may have been prepared already.

Parameters

  targetSemantic | The semantic you intend to use to store the tangents if they are not already present; most likely options are VES_TEXTURE_COORDINATES or VES_TANGENT; you should use texture coordinates if you want compatibility with older, pre-SM2 graphics cards, and the tangent binding otherwise.
  outSourceCoordSet | Reference to a source texture coordinate set which will be populated.
  outIndex | Reference to a destination element index (e.g. texture coord set) which will be populated

## ◆ touch()

virtual void Ogre::Resource::touch | ( | void |  | ) |
| virtualinherited

'Touches' the resource to indicate it has been used.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram, and Ogre::Material.

Referenced by Ogre::Material::touch().

## ◆ unload()

virtual void Ogre::Resource::unload | ( | void |  | ) |
| virtualinherited

Unloads the resource; this is not permanent, the resource can be reloaded later if required.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ unnameSubMesh()

void Ogre::v1::Mesh::unnameSubMesh | ( | const String & | name | ) |
| inherited

Removes a name from a SubMesh.

## ◆ update()

void Ogre::v1::PatchMesh::update | ( | void * | controlPointBuffer,
|  | size_t | width,
|  | size_t | height,
|  | size_t | uMaxSubdivisionLevel,
|  | size_t | vMaxSubdivisionLevel,
|  | PatchSurface::VisibleSide | visibleSide
| ) |  |

Update the mesh with new control points positions.

## ◆ updateManualLodLevel()

void Ogre::v1::Mesh::updateManualLodLevel | ( | ushort | index,
|  | const String & | meshName
| ) |  |
| inherited

Changes the alternate mesh to use as a manual LOD at the given index.

Remarks
  Note that the index of a LOD may change if you insert other LODs. If in doubt, use getLodIndex().

Parameters

  index | The index of the level to be changed.
  meshName | The name of the mesh which will be the lower level detail version.

## ◆ updateMaterialForAllSubMeshes()

void Ogre::v1::Mesh::updateMaterialForAllSubMeshes | ( | void |  | ) |
| inherited

Iterates through all submeshes and requests them to apply their texture aliases to the material they use.

Remarks
  The submesh will only apply texture aliases to the material if matching texture alias names are found in the material. If a match is found, the submesh will automatically clone the original material and then apply its texture to the new material.

  This method is normally called by the protected method loadImpl when a mesh if first loaded.

## Member Data Documentation

## ◆ msOptimizeForShadowMapping

bool Ogre::v1::Mesh::msOptimizeForShadowMapping
| staticinherited

## ◆ OGRE_AUTO_MUTEX

Ogre::Resource::OGRE_AUTO_MUTEX
| inherited

## ◆ sharedBlendIndexToBoneIndexMap

IndexMap Ogre::v1::Mesh::sharedBlendIndexToBoneIndexMap
| inherited

Shared index map for translating blend index to bone index.

Remarks
  This index map can be shared among multiple submeshes. SubMeshes might not have their own IndexMap, they might share this one.

  We collect actually used bones of all bone assignments, and build the blend index in 'packed' form, then the range of the blend index in vertex data VES_BLEND_INDICES element is continuous, with no gaps. Thus, by minimising the world matrix array constants passing to GPU, we can support more bones for a mesh when hardware skinning is used. The hardware skinning support limit is applied to each set of vertex data in the mesh, in other words, the hardware skinning support limit is applied only to the actually used bones of each SubMeshes, not all bones across the entire Mesh.

  Because the blend index is different to the bone index, therefore, we use the index map to translate the blend index to bone index.

  The use of shared or non-shared index map is determined when model data is converted to the OGRE .mesh format.

## ◆ sharedVertexData

VertexData* Ogre::v1::Mesh::sharedVertexData[NumVertexPass]
| inherited

Shared vertex data.

Remarks
  This vertex data can be shared among multiple submeshes. SubMeshes may not have their own VertexData, they may share this one.

  The use of shared or non-shared buffers is determined when model data is converted to the OGRE .mesh format.

The documentation for this class was generated from the following file:

- OgrePatchMesh.h